/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package burp;

import com.gremwell.parsers.GwtParser;
import com.gremwell.parsers.JsonParser;
import com.gremwell.parsers.RequestParser;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author alla
 */
public class BurpExtender implements IBurpExtender {

    IBurpExtenderCallbacks callbacks;

    public void setCommandLineArgs(String[] strings) {
        // do nothing
    }

    public byte[] processProxyMessage(int i, boolean bln, String string, int i1, boolean bln1, String string1, String string2, String string3, String string4, String string5, byte[] bytes, int[] ints) {
        // do nothing
        return bytes;
    }

    public void registerExtenderCallbacks(IBurpExtenderCallbacks ibec) {
        callbacks = ibec;
        addScanGwtMenuItem();
    }

    public void applicationClosing() {
        // do nothing
    }

    public void processHttpMessage(String string, boolean bln, IHttpRequestResponse ihrr) {
        // do nothing
    }

    public void newScanIssue(IScanIssue isi) {
        // do nothing
    }

    private void addScanGwtMenuItem() {
        callbacks.registerMenuItem("Actively scan GWT request(s)", new Scanner(new GwtParser()));
        callbacks.registerMenuItem("Actively scan JSON request(s)", new Scanner(new JsonParser()));
    }

    public class Scanner implements IMenuItemHandler {

        RequestParser parser;

        public Scanner(RequestParser parser) {
            this.parser = parser;
        }

        public void menuItemClicked(String string, IHttpRequestResponse[] ihrrs) {
            for (int i = 0; i < ihrrs.length; i++) {
                try {
                    byte[] request = ihrrs[i].getRequest();
                    String requestAsString = new String(request);
                    List<int[]> insertionPointOffsets = parseRequest(requestAsString);
                    if (insertionPointOffsets == null || insertionPointOffsets.isEmpty()) {
                        callbacks.issueAlert("No insertion points found in request to " + ihrrs[i].getUrl() + ", will not scan it");
                    } else {
                        callbacks.doActiveScan(ihrrs[i].getHost(), ihrrs[i].getPort(), ihrrs[i].getProtocol().equals("https"), request, insertionPointOffsets);
                    }
                } catch (Exception ex) {
                    callbacks.issueAlert("Caught " + ex + " while reading HTTP response: " + ex.getLocalizedMessage());
                }
            }
        }

        private List<int[]> parseRequest(String request) {
            List<int[]> insertionPointOffsets = new ArrayList<int[]>();
            parser.parse(request);

            for (int j = 0; j < parser.getParametersNumber(); j++) {
                if (parser.getParameter(j).getValue() != null) {
                    int[] points = new int[2];
                    points[0] = parser.getParameter(j).getStartOffset();
                    points[1] = parser.getParameter(j).getEndOffset();
                    insertionPointOffsets.add(points);
                }
            }
            if (insertionPointOffsets.isEmpty()) {
                return null;
            } else {
                return insertionPointOffsets;
            }
        }
    }
    /*
    public class JsonScanner implements IMenuItemHandler {
    
    public void menuItemClicked(String string, IHttpRequestResponse[] ihrrs) {
    throw new UnsupportedOperationException("Not supported yet.");
    }
    }
    
    
    } */
}