/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.gremwell.parsers;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author alla
 */
public class CommaSeparatedParser implements RequestParser {

    private String data;
    private List<RequestParameter> parameters = new ArrayList<RequestParameter>();

    public RequestParameter getParameter(int index) {
        return parameters.get(index);
    }

    public int getParametersNumber() {
        return parameters.size();
    }

    public void parse(String data) {
        String[] lines = data.split("\r\n"); // split request into lines
        String pattern = ",|&|\\?"; // match commas, ampersands and question marks
        String[] split = lines[0].split(pattern); // Split the url into comma-separated values
        Pattern p = Pattern.compile(pattern);
        Matcher m = p.matcher(lines[0]);
        if (split.length > 0) {
            m.find();
            int currentComma = m.start();
            do {
                int equalsSignOffset = lines[0].indexOf("=", currentComma + 1);
                boolean found = m.find(currentComma+1);
                int nextComma = found? m.start() : -1;
                if (equalsSignOffset > -1 && nextComma > -1 && equalsSignOffset < nextComma
                        // The current parameter has name and value and is terminstad by comma
                        || nextComma == -1 && equalsSignOffset > -1) {
                    // the current parameter has name and value and is the last parameter

                    RequestParameter name = new RequestParameter();
                    name.setValue(lines[0].substring(currentComma + 1, equalsSignOffset));
                    name.setStartOffset(currentComma + 1);
                    name.setEndOffset(equalsSignOffset);
                    parameters.add(name);
                    RequestParameter value = new RequestParameter();
                    if (nextComma > -1) {
                        value.setValue(lines[0].substring(equalsSignOffset + 1, nextComma));
                        value.setStartOffset(equalsSignOffset + 1);
                        value.setEndOffset(nextComma);
                    } else {
                        value.setValue(lines[0].substring(equalsSignOffset + 1, lines[0].lastIndexOf(".html")));
                        value.setStartOffset(equalsSignOffset + 1);
                        value.setEndOffset(lines[0].lastIndexOf(".html"));
                    }
                    parameters.add(value);
                } else { // The current parameter only has a value
                    RequestParameter value = new RequestParameter();
                    if (nextComma > -1) {
                        value.setValue(lines[0].substring(currentComma + 1, nextComma));
                        value.setStartOffset(currentComma + 1);
                        value.setEndOffset(nextComma);
                    } else {
                        value.setValue(lines[0].substring(currentComma + 1, lines[0].lastIndexOf(".html")));
                        value.setStartOffset(currentComma + 1);
                        value.setEndOffset(lines[0].lastIndexOf(".html"));
                    }
                    parameters.add(value);
                }
                currentComma = nextComma;
            } while (currentComma > -1);
        }
    }
}
