/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.gremwell.parsers;

/**
 *
 * @author alla
 */
public class GwtParser implements RequestParser {

    private String gwtRequest;
    private int version;
    private int flag;
    private int stringTableSize;
    private String[] stringTable;
    private int parametersNumber;
    private RequestParameter[] parameters;
    public static int StringTableOffset = 3;
    public static int ParameterOffset = 4;

    public void parse(String request) {
        int bodyStart = request.indexOf("\r\n\r\n") + 4;
        String body = request.substring(bodyStart);
        this.gwtRequest = body;

        String[] split = gwtRequest.split("\\|");
        version = Integer.parseInt(split[0]);
        flag = Integer.parseInt(split[1]);
        stringTableSize = Integer.parseInt(split[2]);
        stringTable = new String[stringTableSize];
        for (int i = 0; i < stringTableSize; i++) {
            stringTable[i] = split[3 + i];
        }
        int endOfStringTable = StringTableOffset + stringTableSize + ParameterOffset;
        parametersNumber = Integer.parseInt(split[endOfStringTable]);
        parameters = new RequestParameter[parametersNumber];
        int offset = 1;
        for (int i = 0; i < parametersNumber; i++) {
            parameters[i] = new RequestParameter();
            int typeIndex = Integer.parseInt(split[endOfStringTable + 1 + i]);
            String type = split[StringTableOffset + typeIndex - 1];
            String[] typeParts = type.split("/");
            getParameter(i).setType(typeParts[0]);
            String valueIndexString = split[endOfStringTable + offset + parametersNumber + i];
            if(valueIndexString.equals("Q")) { // Skip this and get next value?
                offset++;
                valueIndexString = split[endOfStringTable + offset + parametersNumber + i];                
            }
            int valueIndex = Integer.parseInt(valueIndexString);
            if (valueIndex != 0 && getParameter(i).getType().equals("java.lang.String")) {
                getParameter(i).setValue(split[StringTableOffset + valueIndex - 1]);
                getParameter(i).setStartOffset(nthIndexOf(gwtRequest, '|', StringTableOffset + valueIndex - 2) + 1 + bodyStart);
                getParameter(i).setEndOffset(nthIndexOf(gwtRequest, '|', StringTableOffset + valueIndex - 1) + bodyStart);
            } else {
                getParameter(i).setValue(null);
            }
        }

    }

    public static int nthIndexOf(String text, char needle, int n) {
        for (int i = 0; i < text.length(); i++) {
            if (text.charAt(i) == needle) {
                if (n == 0) {
                    return i;
                }
                n--;
            }
        }
        return -1;
    }

    public int getFlag() {
        return flag;
    }

    public String getGwtRequest() {
        return gwtRequest;
    }

    public RequestParameter getParameter(int index) {
        return parameters[index];
    }

    public int getParametersNumber() {
        return parametersNumber;
    }

    public String[] getStringTable() {
        return stringTable;
    }

    public int getStringTableSize() {
        return stringTableSize;
    }

    public int getVersion() {
        return version;
    }
}
