/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.gremwell.parsers;

import java.io.IOException;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author alla
 */
public class JsonParser implements RequestParser {

    private String data;
    private List<RequestParameter> parameters = new ArrayList<RequestParameter>();

    public RequestParameter getParameter(int index) {
        return parameters.get(index);
    }

    public int getParametersNumber() {
        return parameters.size();
    }

    public void parse(String request) {
        int bodyStart = request.indexOf("\r\n\r\n") + 4;
        this.data = request.substring(bodyStart);
        StringReader reader = new StringReader(data);
        StreamTokenizer tokenizer = new StreamTokenizer(reader);
        try {
            int offset = 0;
            int token = tokenizer.nextToken();
            while (token != StreamTokenizer.TT_EOF) {
                if (token == StreamTokenizer.TT_WORD || token == '"' || token == '\'') {
                    String value = tokenizer.sval;
                    int startOffset = data.indexOf(value, offset) + bodyStart;
                    int endOffset = startOffset + value.length();
                    RequestParameter param = new RequestParameter();
                    param.setValue(value);
                    param.setType("java.lang.String");
                    param.setStartOffset(startOffset);
                    param.setEndOffset(endOffset);
                    parameters.add(param);
                }
                token = tokenizer.nextToken();
            }
        } catch (IOException ex) {
            throw new RuntimeException("IOException while parsing JSON request body", ex);
        }
    }
}
