/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.gremwell.parsers;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author alla
 */
public class GwtParserTest {
    String request = "POST /whatever HTTP/1.1\r\n"+
"Host: berp005:2443\r\n"+
"User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:12.0) Gecko/20100101 Firefox/12.0\r\n"+
"Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n"+
"Accept-Language: en-us,en;q=0.5\r\n"+
"Accept-Encoding: gzip, deflate\r\n"+
"Connection: keep-alive\r\n"+
"Content-Type: text/x-gwt-rpc; charset=utf-8\r\n"+
"X-GWT-Permutation: C85D737C4CAAD1808B5DB1FC80C2A357\r\n"+
"X-GWT-Module-Base: https://whatever/whatever/\r\n"+
"Referer: https://whatever/whatever/\r\n"+
"Content-Length: 283\r\n"+
"Cookie: JSESSIONID=7ee5910385b04188edffa8302e0a\r\n"+
"Pragma: no-cache\r\n"+
"Cache-Control: no-cache\r\n\r\n"+
            "7|0|9|https://whatever/whatever|F5C1B07FE17F07C5229B34130145AD52|com.gremwell.test.whatever|whatever|java.lang.String/2004016611|java.lang.Long/4227064769|0\\!1|Oper|obfuscation|1|2|3|4|5|5|6|5|5|5|0|6|Q|7|8|9|\r\n";


    public GwtParserTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of parse method, of class GwtParser.
     */
    @Test
    public void testParse() {
        System.out.println("parse");
        GwtParser instance = new GwtParser();
        instance.parse(request);
        assertEquals(7, instance.getVersion());
        assertEquals(0, instance.getFlag());
        assertEquals(9, instance.getStringTableSize());
        assertEquals(5, instance.getParametersNumber());
        for(int i =0; i<instance.getParametersNumber(); i++) {
            System.out.println(instance.getParameter(i).getValue());
        }
        assertEquals("obfuscation", instance.getParameter(4).getValue());

        int start = instance.getParameter(4).getStartOffset();
        System.out.println("Value start: " + start);
        int end = instance.getParameter(4).getEndOffset();
        System.out.println("Value end: " + end);
        System.out.println(request.substring(start));
        String substr = request.substring(start, end);
        assertEquals("obfuscation", substr);
    }
}
